<?php
session_start();
if(!isset($_SESSION['username'])){
 header("Location:index.html");
 exit();
}
ob_start();
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Download Management</title>

    <!-- Bootstrap -->
    <link href="css/bootstrap.min.css" rel="stylesheet">
	<script src="js/jquery-1.11.1.min.js"></script>
	<script src="js/checkall.js"></script>
  </head>
  <body>
<div class="navbar navbar-inverse navbar-fixed-top" role="navigation">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target=".navbar-collapse">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand"  style="color: #FFBA02;">Zamani Archive Backend</a>
        </div>
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
			<li class="active"><a href="download_management.php">Download Management</a></li>
            <li class="dropdown">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown">Metadata Management<span class="caret"></span></a>
                <ul class="dropdown-menu" role="menu" style="background-color: #101010;">
                  <li><a href="metaTool/Meta-fy.php" target="_blank" style="color: #777;">Meta-fy<img style="float:right;" src="Images/external_link.png"></a></li>
		  <li class="divider"></li>
                  <li><a href="metaTool/java_docs/index.html"  target="_blank" style="color: #777;">Java Docs<img style="float:right;" src="Images/external_link.png"></a></li>
                </ul>
              </li>
            <li><a href="ingestion.php">Ingestion</a></li>
			<li><a href="login/logout.php">Logout</a></li>
          </ul>
        </div><!--/.nav-collapse -->
      </div>
    </div>
<?php
$content = ob_get_clean();
echo $content;
error_reporting(-1);
ini_set('display_errors', 'On');


//connect to db
$db = pg_connect("host=localhost port=5432 dbname=admin user=postgres password=postgresadmin");

//get file permissions
$result = pg_query($db, "SELECT * FROM permissions;");
$response = pg_fetch_all($result);
//var_dump($response);
//print_r($response);
if (!$response) {       //if no record found, create a permissions record for user
        //add code to test if the  record has been added
        echo 'No Requests Found';
}
else{//append the new pid with state
	//build the top of the user permissions
	echo '<div class="container-fluid">
	<ul class="list-group">
	<li class="list-group-item" style="background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold;">Requested Downloads</li>';

	$count =0;
	//each user
	//build the individual file records
	foreach($response as $user){
		$login_id = $user['login_id'];
		$pid = explode("," , trim($user['pid'], '{}'));
		$state = explode("," , trim($user['state'], '{}'));
		
		
		//determine the number of requests for the user
		$max = 0;
		$total_userRecords = sizeof($pid);
		$index =0;
		
		foreach($state as $status){
		if($status == "requested"){
		
			$pidEscaped = str_replace(':','\:',$pid[$index]);
			$url = 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q=PID:'.$pidEscaped.'&start=0&wt=php';
			//echo $url;
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,$url);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
			$output=curl_exec($ch);
			eval("\$result = " . $output. ";");
			//print_r($result);
			if($result['response']['numFound']!=0)
			{
			$max++;
			}
		}
		$index++;
		}
		
		
		

		if($max>0){
		//retrieve the user's email address
		$login_result = pg_query($db, "SELECT email FROM login WHERE id=".$login_id.";");
		$email = pg_fetch_array($login_result);	
		//var_dump($email);
		pg_free_result($login_result);
		
		
		//header for user record
		echo '<li class="list-group-item" id="'.$login_id.'">
			<span class="badge">'.$max.'</span>
			<form id="form'.$login_id.'" action="permissions/update_permissions.php"  method="post">
			<div style="padding-bottom:15px;">
			<strong>User_id:  </strong> '.$login_id.'<strong> Email: </strong>'.$email['email'].'  
			</div>
			<button class="btn btn-default"  onclick="$(\'#user_'.$login_id.'\').toggle();return false;">Show/Hide</button>
			<button class ="btn btn-default" type="submit" id="" name="">Update Permissions</button>
			<div style="float:right; padding-right:70px;">
				<div class="checkbox"><label><input type="checkbox" id="decline_'.$count.'" name="decline_'.$login_id.'" data-checkbox-name="d'.$login_id.'" class="selectall" onchange="checkAllD('.$count.','.$total_userRecords.')" />Decline all</label></div>
			</div>
			<div style="float:right; padding-right:85px;">
				<div class="checkbox"><label><input type="checkbox" id="accept_'.$count.'" name="accept_'.$login_id.'" data-checkbox-name="a'.$login_id.'" class="selectall" onchange="checkAll('.$count.','.$total_userRecords.')" />Accept All</label></div>
			</div>
			<div id="user_'.$login_id.'" style="display:none;">
			<table class="table table-hover " style="padding-top:20px;">
			<thead>
			<tr>
				<th>Preview</th>
				<th>File Path</th>
				<th>File Type</th>
				<th>File Format</th>
				<th>Collection</th>
				<th>Country</th>
				<th>Date</th>
				<th>Accept</th>
				<th>Decline</th>
			</tr>
			</thead>
			<tbody>';
			for($record=0;$record<$total_userRecords ;$record++){
			if($state[$record]=="requested"){
			
			$pidQuery = $pid[$record];
			$pidEscaped = str_replace(':','\:',$pidQuery);

			$url = 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q=PID:'.$pidEscaped.'&start=0&wt=php';
			//echo $url;
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,$url);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
			$output=curl_exec($ch);
			eval("\$result = " . $output. ";");
			//print_r($result);
			if($result['response']['numFound']==0)
			{
			continue;
			}
/* 			print_r($result['response']['docs'][0]['dc.date']);
			print_r($result['response']['docs'][0]['dc.type']);	
			print_r($result['response']['docs'][0]['name_autocomplete'][1]);	
			print_r($result['response']['docs'][0]['name_autocomplete'][3]);	
 */
			$url = 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?'.$pidQuery.'/datastreams/FILE/content';

			$ch = curl_init();  

			curl_setopt($ch,CURLOPT_URL,$url);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);

			$output=curl_exec($ch);

			//curl_close($ch);

			$deXml = simplexml_load_string($output);
			$deJson = json_encode($deXml);
			$xml_array = json_decode($deJson,TRUE);
			
		
	echo'<tr>
				<td ><div style ="width:100px; height:100px; border: 1px solid #D6D6D6; overflow: hidden;"><img src="http://nala.cs.uct.ac.za/zamaniProject_archive/inc/getScaledImage.php?w=100&amp;h=100&amp;mimeType='.$result['response']['docs'][0]['name_autocomplete'][1].'&amp;pid='.$pidQuery.'"></div></td>
                <td>'.basename($xml_array['server_path']).'</td>
				<td>'.$result['response']['docs'][0]['name_autocomplete'][0].'</td>
                <td>'.$result['response']['docs'][0]['name_autocomplete'][1].'</td>
				<td>'.$result['response']['docs'][0]['name_autocomplete'][4].'</td>
                <td>'.$result['response']['docs'][0]['name_autocomplete'][3].'</td>
				<td>'.$result['response']['docs'][0]['dc.date'].'</td>
			<td>
			<div class="checkbox"><label><input type="checkbox" id="accept_'.$count.'_'.$record.'" name="a_'.$login_id.'_'.$record.'" value="'.$pid[$record].'" data-select-all="accept_'.$login_id.'"  onchange="selectAccept('.$count.','.$record.')"/>Accepted</label></div>
			</td>
			<td>
			<div class="checkbox"><label><input type="checkbox"  id="decline_'.$count.'_'.$record.'" name="d_'.$login_id.'_'.$record.'" value="'.$pid[$record].'" data-select-all="decline_'.$login_id.'"  onchange="selectDecline('.$count.','.$record.')"/>Declined</label></div>
			</td>
			</tr>
			 <input type="hidden" id="request_count_'.$count.'" name="request_count" value="'.$max.'">
			 <input type="hidden" id="login_id'.$login_id.'" name="login_id" value= "'.$login_id.'">
			 <input type="hidden" id="total_userRecords'.$total_userRecords.'" name="total_userRecords" value= "'.$total_userRecords.'">';
			}
			}
		echo '</tbody>
		</table>
		</div>
		</form>
		</li>';
		}
		$count++;
	}

	echo '</ul>
	      </div>';
}

pg_close($db);

?>

 <script src="js/bootstrap.min.js"></script>
  </body>
</html>	
