<?php
session_start();
error_reporting(-1);
ini_set('display_errors', 'On');

 function purgeObject($pid){
	$protocol = "http"; 
	$host = "localhost"; 
	$port = 8080; 
	$context = "fedora"; 
	$req = "DELETE";
	$fedoraUserPwd = "fedoraAdmin:fedoraAdmin"; // username:password 
	$fedoraVerifyPeer = false; // false for ignoring self signed certificates 
	$queryArgs = array(
			 "logMessage" => "purge"); 

	// generate URL, encoding query string 
	$url = sprintf("%s://%s:%d/%s/objects/%s?%s", 
			 $protocol, 
			 $host, 
			 $port, 
			 $context, 
			 $pid, 
			 http_build_query($queryArgs)); 
	//echo $url;
	// this seems to be vital for getting Fedora to recognise the POST content 
	$headers = array("Accept: text/xml", "Content-Type: text/xml"); 

	$curl_opts = array(CURLOPT_RETURNTRANSFER => true, 
			 CURLOPT_URL => $url, 
			 CURLOPT_HTTPHEADER => $headers, 
			 CURLOPT_USERPWD => $fedoraUserPwd, 
			 CURLOPT_HTTPAUTH => CURLAUTH_BASIC, 
			 CURLOPT_SSL_VERIFYPEER => $fedoraVerifyPeer, 
			 CURLOPT_CUSTOMREQUEST => $req);
			 //CURLOPT_POSTFIELDS => $xml); 

	$ch = curl_init(); 
	curl_setopt_array($ch, $curl_opts); 
	$purgeTime =  curl_exec($ch); // get new PID returned 

	if(strpos($purgeTime,'Object not found')==false){
	echo "Time: ".$purgeTime ." Pid:".$pid."</br>"; 
	}
	else{
	echo $purgeTime."</br>";
	}
 } 

//get list of files in directory from selector value
//Directory --> $_POST['parent_collection']
 
 if(isset($_POST['selected_collection'])){
	$path = $_POST['selected_collection'];

	$dir = new DirectoryIterator("../".$path );
	//echo "</br>";
	foreach ($dir as $fileinfo) {	
		if (!$fileinfo->isDot()) {
			//Only process xml files
			if ($fileinfo->getExtension()=="xml"){
				
				$filename = $fileinfo->getFilename();

				if (strpos($filename,'Collection') == false ){
					$filenameNoExtension = $fileinfo->getBasename('.' .$fileinfo->getExtension());
					//$PID = substr($filenameNoExtension,0,6).':'.substr($filenameNoExtension,-7);
					
					$result = preg_split('/(?<=\d)(?=[a-z])|(?<=[a-z])(?=\d)/i', $filenameNoExtension);
					$PID = $result[0].":".$result[1];
					
					//echo $PID;
					purgeObject($PID);
				}
				else{
					
					if(strpos($filename,'Collection2') == false){
						purgeObject(str_replace("1",":1",rtrim(basename($filename), ".xml")));
						
					}
					else{
						purgeObject(str_replace("2",":1",rtrim(basename($filename),".xml")));
					}
				}
			}
		}
	}
	include 'updateIndexFromFOXML.php';
	include 'updateIndexOptimize.php';
 }
 
	if(isset($_POST['pids'])){
		$pids = explode(",",$_POST['pids']);
		//print_r($pids);	
		foreach($pids as $PID){
			 purgeObject($PID);
		}
		include 'updateIndexFromFOXML.php';
		include 'updateIndexOptimize.php';
	}
	
?>