<?php
session_start();
error_reporting(-1);
ini_set('display_errors', 'On');
$db = pg_connect("host=localhost port=5432 dbname=admin user=postgres password=postgresadmin");

//var_export($_POST);
//number of records submitted
$login_id = $_POST['login_id'];
//print_r($login_id);
$total_userRecords = $_POST['total_userRecords'];
$format = "File Name:%-35s State:%-12s Time:%-s\n";
$message = "Your permissions for the following files have changed:\n\n";
$countAccepted =0;
$countDeclined =0;

$file = "permissions.log";
$current =  file_get_contents($file);

for($i=0;$i<$total_userRecords;$i++){
	//update user permissions for pid to 'accepted'
	$acceptString = "a_".$login_id."_".$i;
	if(isset($_POST[$acceptString])){	
		//get pid list for user
		$result_getPids    = pg_query($db,"SELECT pid FROM permissions WHERE login_id=".$login_id);
		$response_getPids  = pg_fetch_all($result_getPids);
		$pidArray = str_replace(",","','",trim($response_getPids[0]['pid'],"{}"));
		
		//find index of pid for updating mathcing state
		$result_getIndex   = pg_query($db,"SELECT array_search('".$_POST[$acceptString]."', ARRAY['".$pidArray."']);");
		$response_getIndex =pg_fetch_all($result_getIndex);
		$pidIndex = $response_getIndex[0]['array_search'];
		
		//update permissions for pid to 'accepted'
		$result_update = pg_query($db, "UPDATE permissions SET state[".$pidIndex."]='accepted' WHERE login_id=".$login_id.";");
		$re = pg_fetch_all($result_update);

		//log update
		
		$current .= "Admin: ".$_SESSION['name']." User_id: ".$login_id." Pid: ".$_POST[$acceptString]." State: 'accepted' Time: ".date("j F, Y, g:i a")."\n";
		
		
		//build email
		$url = 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?'.$_POST[$acceptString].'/datastreams/FILE/content';
		$ch = curl_init();  
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$output=curl_exec($ch);
		curl_close($ch);
		$deXml = simplexml_load_string($output);
		$deJson = json_encode($deXml);
		$xml_array = json_decode($deJson,TRUE);
		$fileName = basename($xml_array['server_path']);
		$message .= sprintf($format,$fileName, "accepted",date("j F, Y, g:i a"));
		$countAccepted++;
	}

	//update user permissions for pid to 'declined'
	$declineString = "d_".$login_id."_".$i;
	if(isset($_POST[$declineString])){
		
		//get pid list for user
		$result_getPids    = pg_query($db,"SELECT pid FROM permissions WHERE login_id=".$login_id);
		$response_getPids  = pg_fetch_all($result_getPids);
		$pidArray = str_replace(",","','",trim($response_getPids[0]['pid'],"{}"));
		
		//find index of pid for updating mathcing state
		$result_getIndex   = pg_query($db,"SELECT array_search('".$_POST[$declineString]."', ARRAY['".$pidArray."']);");
		$response_getIndex =pg_fetch_all($result_getIndex);
		$pidIndex = $response_getIndex[0]['array_search'];
		
		//update permissions for pid to 'declined'
		$result_update = pg_query($db, "UPDATE permissions SET state[".$pidIndex."]='declined' WHERE login_id=".$login_id.";");
		
		//log update
		
		$current .= "Admin: ".$_SESSION['name']." User_id: ".$login_id." Pid: ".$_POST[$declineString]." State: 'declined' Time: ".date("j F, Y, g:i a")."\n";
		
		
		//build email
		$url = 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?'.$_POST[$declineString].'/datastreams/FILE/content';
		$ch = curl_init();  
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$output=curl_exec($ch);
		curl_close($ch);
		$deXml = simplexml_load_string($output);
		$deJson = json_encode($deXml);
		$xml_array = json_decode($deJson,TRUE);
		$fileName = basename($xml_array['server_path']);
		$message .= sprintf($format,$fileName,"declined",date("j F, Y, g:i a"));
		$countDeclined++;
	}
	
}
//update log
file_put_contents($file, $current);

//notify user
$message .= "\nTotal: ".($countAccepted + $countDeclined)."    Accepted: ".$countAccepted."    Declined: ".$countDeclined."\n";
$message .= "\nRegards\nThe Zamani Team\n".date("j F, Y, g:i a");
$result_email = pg_query($db, "SELECT email FROM login WHERE id=".$login_id.";");
$response_email = pg_fetch_assoc($result_email);
mail($response_email['email'], 'Zamani Archive - File Permissions Updated', $message);

//redirect to download management page
echo "<script>window.location = 'http://nala.cs.uct.ac.za/zamaniProject_archive/admin/download_management.php'</script>";

function getFileName(){
	
}

?>
