<?php
session_start();
ob_start();
?>
<!DOCTYPE html>
<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

	<title>Zamani Archive - Search Interface</title>
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<link href="styles/styles.css" rel="stylesheet">
	<link rel="stylesheet" type="text/css" href="styles/normalize.css">
	<link rel="stylesheet" type="text/css" href="styles/simplePagination.css">
	<link rel="stylesheet" type="text/css" href="styles/bootstrap.css">
	<link rel="stylesheet" type="text/css" href="styles/result-light.css">
	<link type="text/css" rel="stylesheet" href="styles/style.css" />
	

	<script type="text/javascript" src="scripts/jquery-1.7.1.js"></script>
	<script src="scripts/jquery-1.11.1.min.js"></script>
	<script type="text/javascript" src="scripts/jquery.autocomplete.min.js"></script>
	
	<script src="https://maps.googleapis.com/maps/api/js?v=3.exp"></script>
	
	<script type="text/javascript" src="scripts/jquery.simplePagination.js"></script>
	<script type="text/javascript" src="scripts/jquery.timeago.js"></script>
	<script type="text/javascript" src="scripts/jquery.leanModal.min.js"></script>
	<script type="text/javascript" src="scripts/functions.js"></script>
	<script src="scripts/jquery.validate.min.js"></script>
	<script src="scripts/additional-methods.min.js"></script>
	
</head>
<body>
	<div id="header" class="container text-center">
			<div style="position: relative; left: 0; top: 0; width: 100%;">

<?php
$content = ob_get_clean();
echo $content;

if(isset($_SESSION['email']) && isset($_SESSION['id'])){
	      echo '<a style="float:right; font-size:14px;" class="btn_normal_2 btn_red" href="inc/login/logout.php">logout</a><a style="float: right; text-decoration: underline; color: #1a0dab;"  class="btn_normal_2 btn_logged_in" href="http://nala.cs.uct.ac.za/zamaniProject_archive/download_user.php">'.$_SESSION['email'].'</a>';
}
else{
              echo '<a style="float: right;" id="modal_trigger" href="#modal" class="btn_normal_2 btn_index">Click here to Login / Register</a>';
}

ob_start();
?>
			  <a href="index.php">
			  <img src="images/zamani_project_header_2.jpg" style="position: relative; top: 0; left: 0;" alt="Zamani Header" title="Go to the Zamani Archive Home page" width="100%">
			  <img id="giraffe" src="images/giraffe.png" style="position: absolute; top: 82px; left: 30%;" alt="giraffe" width="5%">
			  </a>
			</div>
	</div>
	<div class="navbar navbar-default navbar-static-top searchbar">
		<div class="container">

            <div class="row">
	            <div class="col-lg-3">
		            <div class="navbar-collapse collapse" id="navbar-main"  style="float:right;">
		                <ul class="nav navbar-nav">
		                    <li> <a id="archive-menu" href="index.php" class="navbar-brand" style="background-color: #FFBA02; color:#000;">Archive</a></li>
<?php
$content = ob_get_clean();
echo $content;

if(isset($_SESSION['email']) && isset($_SESSION['id'])){
	      echo ' <li> <a style="margin-left: 10px; " href="download_user.php" class="navbar-brand">Account</a></li>';
}

ob_start();
?>
		                </ul>
		            </div>
	            </div>
                <div class="col-lg-9">
	                <form id='search_form' class="navbar-form navbar-right" role="search" style="width:100%; margin-right:0px;">
				        <div class="form-group" style="width:100%">
							<div class="input-group">
				          		<input id="autocomplete" class="form-control" type="text" onfocus="unsetPlaceholder(this)"  onblur="setPlaceholder(this)" placeholder="What can we help you find?"   />
  								<span class="input-group-btn">
							        <button class="btn btn-default" type="submit">
							        	<span class="glyphicon glyphicon-search"></span>
							        </button>
						      	</span>
				        	</div>
				        </div>
			      	</form>
		      	</div>
	      	</div>

		</div>
	</div>
	<div class="container">
		<div class="row">
			<div class="col-lg-3">
				<div id="facet_content"></div>
			</div>
			<div class="col-lg-9">
				
				<input type="hidden" id="selectedCollectionQuery" name="selectedCollectionQuery" value="0">
				<input type="hidden" id="searchByTypeQuery" name="searchByTypeQuery" value="0">
				<div class="page-header" id="search-title">
					<h3>Search results</h3>
				</div>
				<div id="documentStatus">
				</div>
				<ul class="list-group">
					<li id="searchByCollectionHeader" class="list-group-item" style="background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold;">Search By Collection</li><li style="border: 1px solid #dddddd; margin-bottom: -1px;">
						<div id="map-canvas">
						</div> 
					</li>
				</ul>
				<div id="info_and_search_content" style="width: 100%; border: solid 1px #ccc; border-bottom:none; margin-right: 120px; margin-top: 10px; padding: 10px; ">	
				</div>
				<div id="pagination_content" style="width: 100%; border: solid 1px #ccc; border-top: none; margin-right: 120px; padding-left: 10px; padding-right: 10px; text-align: center; "><input type="hidden" id="numberOfDocuments" name="numberOfDocuments" value="0"><div id="pagination" class="pagination light-theme simple-pagination" ></div></div>
			</div>
		</div>
	</div>
		<div class="container">
			<div id="modal" class="popupContainer" style="display:none;">
				<header class="popupHeader">
					<span class="header_title">Login</span>
					<span class="modal_close">(X)</span>
				</header>	
				<section class="popupBody">
					<div class="login_main">
						<div class="">
					</div>
						<div class="action_btns">
							<div class="one_half"><a href="#" id="login_form" class="btn_normal_2">Login</a></div>
							<div class="one_half last"><a href="#" id="register_form" class="btn_normal_2">Sign up</a></div>
						</div>
					</div>

					<!-- Username & Password Login form -->
					<div class="user_login" name ="user_login" id="user_login">
						<form id="login" name="login">
							<label>Email Address</label>
							<input id="email_login" name="email_login" type="email" required="required" />
							<br />

							<label>Password</label>
							<input id="password_login" name="password_login" type="password" required="required" />
							<br />

							<div class="action_btns">
								<div class="one_half" ><input type="submit" class="btn_normal_2 btn_red" id="login_button" /></div>
								<div class="one_half last"><button href="#" class="btn_normal_2 back_btn" > Back</button></div>
							</div>
							<div id="login_response" style="margin-top:15px;"></div>
						</form>

						<a href="#" id="changepass_form" class="forgot_password">Forgotten your password?</a>
					</div>

					<!-- Register Form -->
					<div class="user_register" name ="user_register" id="user_register">
						<form id="register" name="register"  >
							<label>Email Address</label>
							<input  id="email_register" name="email_register" type="email" required="required"/>
							<br />

							<label>Password</label>
							<input  id ="password_register" name="password_register" type="password" required="required"/>
							<br />

							<label>Terms & conditions</label>
                            I certify that I agree with the <a href="#" id="tac" name="tac">Terms & Conditions</a>
							<input id="terms_and_conditions" name="terms_and_conditions" type="checkbox" required="required" />
							<br />
							<br />
							<div class="action_btns">
								<div class="one_half" ><input type="submit" class="btn_normal_2 btn_red" id="register_button" /></div>
								<div class="one_half last" ><button href="#" class="btn_normal_2 back_btn" > Back</button></div>
							</div>
						</form>
						<div id="register_response" style="margin-top:15px;"></div>
					</div>
					
					<!-- Change Password Form-->
					<div class="user_changepass" name ="user_changepass" id="user_changepass">
                            <form id="changepass" name="changepass"  >
								<label>Email Address</label>
								<input  id="email_changepass" name="email_changepass" type="email" required="required"/>
								<br />
								<div class="action_btns">
									<div class="one_half" ><input type="submit" class="btn_normal_2 btn_red" id="changepass_button" /></div>
									<div class="one_half last" ><button href="#" class="btn_normal_2 back_btn" > Back</button></div>
								</div>
							</form>
							<div id="change_response" style="margin-top:15px;"></div>
					</div>
					
					<div class="terms" name ="terms" id="terms" style="overflow-y:scroll; height:325px;" >
                       <h4>The standard Lorem Ipsum passage, used since the 1500s</h4>

						"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."

						<h4>Section 1.10.32 of "de Finibus Bonorum et Malorum", written by Cicero in 45 BC</h4>

						"Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?"

						<h4>1914 translation by H. Rackham</h4>

						"But I must explain to you how all this mistaken idea of denouncing pleasure and praising pain was born and I will give you a complete account of the system, and expound the actual teachings of the great explorer of the truth, the master-builder of human happiness. No one rejects, dislikes, or avoids pleasure itself, because it is pleasure, but because those who do not know how to pursue pleasure rationally encounter consequences that are extremely painful. Nor again is there anyone who loves or pursues or desires to obtain pain of itself, because it is pain, but because occasionally circumstances occur in which toil and pain can procure him some great pleasure. To take a trivial example, which of us ever undertakes laborious physical exercise, except to obtain some advantage from it? But who has any right to find fault with a man who chooses to enjoy a pleasure that has no annoying consequences, or one who avoids a pain that produces no resultant pleasure?"

						Section 1.10.33 of "de Finibus Bonorum et Malorum", written by Cicero in 45 BC

						"At vero eos et accusamus et iusto odio dignissimos ducimus qui blanditiis praesentium voluptatum deleniti atque corrupti quos dolores et quas molestias excepturi sint occaecati cupiditate non provident, similique sunt in culpa qui officia deserunt mollitia animi, id est laborum et dolorum fuga. Et harum quidem rerum facilis est et expedita distinctio. Nam libero tempore, cum soluta nobis est eligendi optio cumque nihil impedit quo minus id quod maxime placeat facere possimus, omnis voluptas assumenda est, omnis dolor repellendus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Itaque earum rerum hic tenetur a sapiente delectus, ut aut reiciendis voluptatibus maiores alias consequatur aut perferendis doloribus asperiores repellat."

						<h4>1914 translation by H. Rackham</h4>

						"On the other hand, we denounce with righteous indignation and dislike men who are so beguiled and demoralized by the charms of pleasure of the moment, so blinded by desire, that they cannot foresee the pain and trouble that are bound to ensue; and equal blame belongs to those who fail in their duty through weakness of will, which is the same as saying through shrinking from toil and pain. These cases are perfectly simple and easy to distinguish. In a free hour, when our power of choice is untrammelled and when nothing prevents our being able to do what we like best, every pleasure is to be welcomed and every pain avoided. But in certain circumstances and owing to the claims of duty or the obligations of business it will frequently occur that pleasures have to be repudiated and annoyances accepted. The wise man therefore always holds in these matters to this principle of selection: he rejects pleasures to secure other greater pleasures, or else he endures pains to avoid worse pains."

						<div class="one_half" style="margin-top:15px;"><button  href="#" class="btn_normal_2 terms_Back" id="termsBack" name="termsBack"> Back</button></div>
					</div>
									
				</section>
		</div>
		<div class="container">
			<div id="imageViewer" class="popupImageContainer" style="display:none; top: 50%;">
				<header class="popupImage">
					<img src="http://benalman.com/grab/32c76f.png" alt="Smiley face" width="42" height="42">
				</header>	
			</div>
		</div>
		
		<div class="container">
			<div id="requestModal" class="popupContainer" style="display:none;">
				<header class="popupHeader">
					<span class="header_title">Request File</span>
					<span class="modal_close">(X)</span>
				</header>
				
				<section class="popupBody">
					<h4>Reason for request:</h4>
					<textarea id="request_message" name="request_message" form="request" rows="6" cols="55" autofocus	></textarea>
					<form id="request" name="request">
					 <input type="hidden" id="request_string"/>
					 <input class="btn_normal_2" type="submit" value="request"/>
					 </form>
					  
				</section>
				
			</div>
		</div>

		
		<script type="text/javascript">
			$("#requestModal_trigger").leanModal({top : 150, overlay : 0.6, closeButton: ".modal_close" });	
		
			$("#modal_trigger").leanModal({top : 150, overlay : 0.6, closeButton: ".modal_close" });
			$(function(){
				$(".terms").hide();
				//Login Form
				$("#login_form").click(function(){
					$(".login_main").hide();
					$(".user_changepass").hide();
					$(".user_login").show();
					return false;
				});
				
				//Password Form
				$("#changepass_form").click(function(){
                $(".user_login").hide();
			    $(".user_changepass").show();
				$(".header_title").text("Change Password");
                return false;
			    });
				
				//Register Form
				$("#register_form").click(function(){
					$(".login_main").hide();
					$(".user_changepass").hide();
					$(".user_register").show();
					$(".header_title").text("Register");
					return false;
				});
				
				//Terms and Conditions
				$("#tac").click(function(){
					$(".user_register").hide();
					$(".terms").show();
					$(".header_title").text("Terms and Conditions");
					return false;
				});

				//Terms Back
				$(".terms_Back").click(function(){
					$(".terms").hide();
					$(".user_register").show();
					$(".header_title").text("Register");
					return false;
				});
				
				// Going back to Login Main Screen
				$(".back_btn").click(function(){
					$(".user_login").hide();
					$(".user_register").hide();
					$(".user_changepass").hide();
					$(".login_main").show();
					$(".header_title").text("Login");
					return false;
				});
		
				});

				$(document).ready(function () {
				
				
				$("form").each(function(){
				$(this).validate({
				submitHandler: function (form) { 
					if(form["name"]=="register"){
					register();
					}
					if(form["name"]=="login"){
					login();
					}
					if(form["name"]=="changepass"){
					changepass();
					}
					if(form["name"]=="request"){
					request();
					}
					}
				});  
				});
				});
				
				function request(){

					var pidArray = {};
					var pids = $("#request_string").val().split(',');
					for(i=0; i<pids.length;i++){
					var pidIndex = i+1;
					pidArray[pidIndex] = pids[i];
					}
					
					var emailMessage = $("#request_message").val();

					var dataString = {pids:pidArray,email:emailMessage};
					$.ajax({
						type:"POST",
						url:"inc/download/download_request.php",
						data: dataString,
						cache: false,
						success: function(html){
						window.location.href ='';
						alert(html);
						}
					});

				}
				
				function register(){

				var email = $("#email_register").val();
				var password = $("#password_register").val();
				var dataString = {1:email , 2:password};

				$.ajax({
					type:"POST",
					url:"inc/login/register.php",
					data: dataString,
					cache: false,
					success: function(html){
						if(html="Registration Successful!"){
							window.location.href ='';
							alert("Registation successful, check your email to activate your account.");
						}
						else{
						$("#register_response").html(html);
						}
					}
				});

				}

				function login(){
				//alert("working_login");
				var email = $("#email_login").val();
				var password = $("#password_login").val();
				var dataString = {1:email , 2:password};
				$.ajax({
					type:"POST",
					url:"inc/login/checklogin.php",
					data: dataString,
					cache: false,
					success: function(html){
						if(html=="logged in"){
						window.location.href ='';
						}
						else{
						//alert(html);
						$("#login_response").html(html);
						}
					}
				});
				}

				function changepass(){
					//alert("working_login");
					var email = $("#email_changepass").val();
					var dataString = {1:email};
					$.ajax({
							type:"POST",
							url:"inc/login/changepass.php",
							data: dataString,
							cache: false,
							success: function(html){
								//alert(html);
							if(html =="Password Changed!"){
								alert(html);
								$("#login_form").click();
							}
								$("#change_response").html(html);
									
							}
					});
				}

		</script>
		<script type="text/javascript" src="scripts/bootstrap.min.js"></script>
	</body>
	</html>
<?php
$content = ob_get_clean();
echo $content;
?>
